#------------------------------------------------------------------------------
#                                                                            --
#     USE OF SOFTWARE. This software contains elements of software code      --
#     which is the property of Nallatech Limited (the "Nallatech Software"). --
#     Use of the Nallatech Software by you is permitted only if you hold a   --
#     valid license from Nallatech Limited or a valid sub-license from a     --
#     licensee of Nallatech Limited. Use of such software shall be governed  --
#     by the terms of such license or sub-license agreement.                 --
#                                                                            --
#     This Nallatech Software is protected by copyright law, patent law and  --
#     international treaties. Unauthorized reproduction or distribution of   --
#     this software, or any portion of it, may result in severe civil and    --
#     criminal penalties, and will be prosecuted to the maximum extent       --
#     possible under law.                                                    --
#                                                                            --
#     (c) Copyright 2001 - 2005 Nallatech Limited.                           --
#     All rights reserved.                                                   --
#                                                                            --
#------------------------------------------------------------------------------
#
# DIMEtalk Project : C:\Users\gstitt\Documents\teaching\fall10\labs\sram_test_clean\provided_code\dt\dt.dt3
#
# Filename : C:\Users\gstitt\Documents\teaching\fall10\labs\sram_test_clean\provided_code\dt\dimebuild.tcl
#
# Creator : DIMEtalk V3.0
#
# Created : 10/26/2010 4:55:56 PM
#
#------------------------------------------------------------------------------
# Main Code
#------------------------------------------------------------------------------

############################
# Read in description written by DTDesign
############################

if {[catch {source sysdesc.tcl} result]} {
  puts stdout "Error reading system description : $result"
  exit
}

set timestartall [clock sec]

foreach {device} $devices {
  set buildfile [file dirname [lindex $device 1]]
  set buildfile [file join $buildfile "build.tcl"]
  if [file exists $buildfile] {
    puts stdout "Building firmware for device [lindex $device 0] with $buildfile"
    set cwd [pwd]
    cd [file dirname $buildfile]
    if [catch {source build.tcl} res] {
      puts "Error running build $buildfile : $res"
    }
    cd $cwd
  }
}

set timefinishall [clock sec]
puts "\nBuild Finish time: [clock format $timefinishall -format %H:%M:%S] of all devices."
puts "Total elapsed build time: [clock format [ expr $timefinishall - $timestartall ] -format %H:%M:%S] of all devices."
